program Splitter_de_archivos_de_texto;

{  }
{                                                                        }
{   Splitter v0.1                        Por Iigo Hervas, "Hayawata"   }
{                                                                        }
{  }

CONST version = 'Splitter v0.1';

{  }


VAR    { Variables globales }

  ArchivoEntrada : text;    { Archivo a trocear }
  NombreArchivoEntrada : string;
  CuantosKB : byte;         { KBytes mx (entendidos como 1.000 Bytes) }
  NombreSalida : string;    { Nombre para los archivos de salida }


{  }

procedure ErrorFaltanParametros;
  begin
    writeln;
    writeln;
    writeln(#32+version);
    writeln;
    writeln;
    writeln(' USO:  SPLIT  ArchivoEntrada  [ num KBytes  [ NombreSalida ] ]');
    writeln;
    writeln;
    writeln('         - ArchivoEntrada = Nombre del archivo a trocear.');
    writeln;
    writeln('         - num KBytes     = Cuntos Kilobytes (como mximo) podr tener');
    writeln('                            cada archivo creado. Por defecto es 25.');
    writeln('                            Rango de valores: 1..255');
    writeln;
    writeln('         - NombreSalida   = Nombre que tendrn los archivos creados.');
    writeln('                            Por defecto, es el mismo que el del Origen.');
    writeln;
    writeln;
    writeln(' EJEMPLO:  "SPLIT  libro.txt  20  salida"   Creara salida.001, salida.002 ...');
    writeln;
    writeln;
    halt;
  end;


{  }

procedure ErrorArchivoEntrada ( Arch : string );
  begin
    writeln;
    writeln;
    writeln(#32+version);
    writeln;
    writeln;
    writeln(' ERROR: No se encuentra el archivo: "'+Arch+'"');
    writeln;
    writeln;
    halt;
  end;


{  }

procedure ErrorCuantosKB;
  begin
    writeln;
    writeln;
    writeln(#32+version);
    writeln;
    writeln;
    writeln(' ERROR: "num KBytes" debe ser un nmero entre 1 y 255.');
    writeln;
    writeln;
    halt;
  end;


{  }

procedure MuestraInfo;
  begin
    writeln;
    writeln;
    writeln(#32+version);
    writeln;
    writeln;
    writeln(' Archivo de Entrada :  '+NombreArchivoEntrada);
    writeln;
    writeln('        Mx. KBytes :  ',CuantosKB);
    writeln;
    writeln(' Archivos de Salida :  '+NombreSalida+'.###');
    writeln;
    writeln;
  end;


{  }

function Num2Ext ( num : integer ) : string;
  { Recibe un nmero entero, y lo devuelve como cadena, pero con '0' delante
    hasta completar 3 caracteres }
  var devolver : string;
  begin
    str(num,devolver);
    while length(devolver)<3 do devolver := '0'+devolver;
    Num2Ext := devolver;
  end;


{  }

procedure ProcesaArchivo;
  var lin : string;
      BytesEnEsteArchivo : longint;
      NumEsteArchivo : integer;   { Para poder ponerle la extensin }
      ArchivoSalida : text;

  begin

    NumEsteArchivo := 1;
    BytesEnEsteArchivo := 0;

    Assign ( ArchivoSalida , NombreSalida+'.001' );
    rewrite ( ArchivoSalida );

    while not eof(ArchivoEntrada) do begin

      readln ( ArchivoEntrada , lin );
      inc ( BytesEnEsteArchivo , length(lin) );
      inc ( BytesEnEsteArchivo , 2 );  { Hay que tener en cuenta el 0A y 0D }

      if (BytesEnEsteArchivo > CuantosKB*1000) then begin
        { Cambiar de archivo }
        close ( ArchivoSalida );
        inc ( NumEsteArchivo );
        Assign ( ArchivoSalida , NombreSalida+'.'+Num2Ext(NumEsteArchivo) );
        rewrite ( ArchivoSalida );
        BytesEnEsteArchivo := length(lin);
      end;

      writeln ( ArchivoSalida , lin );

    end;

    close ( ArchivoEntrada );
    close ( ArchivoSalida );
    writeln;

  end;


{  }

var kk : word;

begin

  if (ParamCount<1) then ErrorFaltanParametros;

  NombreArchivoEntrada := ParamStr(1);
  Assign ( ArchivoEntrada , NombreArchivoEntrada );

  {$I-} reset ( ArchivoEntrada ); {$I+}
  if (IOResult<>0) then ErrorArchivoEntrada(NombreArchivoEntrada);

  if (ParamCount>1) then begin { Especifica "CuantosKB" }
    val(ParamStr(2),CuantosKB,kk);
    if (CuantosKB=0) then ErrorCuantosKB;
  end else
    CuantosKB := 25;

  if (ParamCount>2) then { Especifica "NombreSalida" }
    NombreSalida := ParamStr(3)
  else begin
    kk := 1;  { Vamos a buscar el '.' en "nombre"... }
    while (kk<=length(NombreArchivoEntrada)) and (NombreArchivoEntrada[kk]<>'.') do inc(kk);
    NombreSalida := copy(NombreArchivoEntrada,1,kk-1);
  end;

  MuestraInfo;
  ProcesaArchivo;

end.